=== debian/changelog ===
libnetconf2 (1.1.16-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Thu, 14 Jan 2021 11:35:31 -0500

libnetconf2 (1.1.16-1) unstable; urgency=low

  * Initial packaging (Closes: #976701)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 4 Dec 2020 09:02:12 +0100
