=== debian/changelog ===
libnetconf2 (2.0.24-3) unstable; urgency=medium

  * Add proper Multi-Arch headers

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 10:01:26 +0100

libnetconf2 (2.0.24-2) unstable; urgency=medium

  * Change the libnetconf2-dev Dependency to libyang2-dev

 -- Ondřej Surý <ondrej@debian.org>  Wed, 24 Nov 2021 20:33:04 +0100

libnetconf2 (2.0.24-1) unstable; urgency=medium

  * Use wrap-and-sort -a to sort file in d/ directory
  * New upstream version 2.0.24
  * Bump the libyang dependency to libyang2-dev
  * Update the shared library package for SONAME bump
  * Update the libnetconf2-2 symbols

 -- Ondřej Surý <ondrej@debian.org>  Sat, 13 Nov 2021 16:23:37 +0100
