=== debian/control ===
--- 
+++ 
@@ -6,17 +6,18 @@
 Build-Depends: cmake,
                debhelper-compat (= 12),
                doxygen,
-	       pkg-config,
                graphviz,
-               libyang-dev (>= 1.0.182),
-	       libssl-dev,
-	       libssh-dev
+               libssh-dev,
+               libssl-dev,
+               libyang2-dev,
+               pkg-config
 Homepage: https://github.com/CESNET/libnetconf2
 
 Package: libnetconf2-doc
 Depends: ${misc:Depends}
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Description: NETCONF protocol library [docs]
  NETCONF library in C intended for building NETCONF clients and servers. NETCONF
  is the NETwork CONFiguration protocol introduced by IETF.
@@ -37,7 +38,7 @@
  .
  This package contains the documentation.
 
-Package: libnetconf2-1
+Package: libnetconf2-2
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -65,12 +66,13 @@
  This package contains the shared C library.
 
 Package: libnetconf2-dev
-Depends: libnetconf2-1 (= ${binary:Version}),
-         libyang-dev (>= 1.0.182),
+Depends: libnetconf2-2 (= ${binary:Version}),
+         libyang2-dev,
          ${misc:Depends},
          ${shlibs:Depends}
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Description: NETCONF protocol library [C development]
  NETCONF library in C intended for building NETCONF clients and servers. NETCONF
  is the NETwork CONFiguration protocol introduced by IETF.
